/**
 * @file
 * Snippet snippetHtmlSource behavior.
 */

(function ($, Drupal) {

  'use strict';

  Drupal.behaviors.snippetHtmlSource = {
    attach: function () {

      var $sourceTextArea = $('[data-drupal-selector="snippet-html-source"]')
        .once('snippet_html_source');

      if (!$sourceTextArea[0]) {
        return;
      }

      /* global CodeMirror */
      if (typeof CodeMirror === 'undefined') {
        alert(Drupal.t('CodeMirror library is not loaded!'));
        return;
      }


      CodeMirror.fromTextArea($sourceTextArea[0], {
        mode: 'text/html',
        lineNumbers: true,
        readOnly: true,
        foldGutter: true,
        gutters: ['CodeMirror-linenumbers', 'CodeMirror-foldgutter']
      });

    }
  }

}(jQuery, Drupal));
