<?php

namespace Drupal\Tests\snippet_manager\Functional;

/**
 * Test for settings form.
 *
 * @group snippet_manager
 */
class SettingsFormTest extends TestBase {

  /**
   * Test callback.
   */
  public function testSettingsForm() {
    $this->drupalGet('admin/structure/snippet/settings');

    $form_prefix = '//form[@id="snippet-manager-settings"]';
    $codemirror_prefix = $form_prefix . '/details[@id="edit-codemirror"]';
    $this->assertXpath($codemirror_prefix . '/summary[text() = "CodeMirror"]');
    $this->assertXpath($codemirror_prefix . '//input[@name="codemirror[cdn]" and @checked="checked"]');
    $this->assertXpath($codemirror_prefix . '//select[@name="codemirror[theme]"]/option[@value="default" and @selected="selected"]');
    $this->assertXpath($codemirror_prefix . '//select[@name="codemirror[mode]"]/option[@value="html_twig" and @selected="selected"]');

    $edit = [
      'codemirror[cdn]' => FALSE,
      'codemirror[theme]' => '3024-day',
      'codemirror[mode]' => 'twig',
    ];
    $this->drupalPostForm(NULL, $edit, 'Save configuration');

    $this->assertStatusMessage('The configuration options have been saved.');

    $this->assertXpath($codemirror_prefix . '//input[@name="codemirror[cdn]" and not(@checked)]');
    $this->assertXpath($codemirror_prefix . '//select[@name="codemirror[theme]"]/option[@value="3024-day" and @selected="selected"]');
    $this->assertXpath($codemirror_prefix . '//select[@name="codemirror[mode]"]/option[@value="twig" and @selected="selected"]');
  }

}
